%let work_dir=C:\Users\okuegler\Documents\Client_request\Barbara_Bamberger\2014\CP_update - Version 2\Fixed_siteclcd;
%let threshold = 4;

libname eco "&work_dir.\eco.accdb";
libname sas "C:\Users\okuegler\Documents\nims\2013\FIADB\National\SAS";
%include "&work_dir.\tabling_program\run_tabeling.sas";
	
%let script_dir=&work_dir.\SAS_supersection;
%let result_dir=&work_dir.\results_supersection;


data car_communities_mod;
  set eco.car_communities;
run;
data forest_type(keep = forest_type fortypcd);
  set eco.ref_forest_type;
  forest_type = meaning;
  fortypcd = value;
run;

proc sort data = forest_type;
  by forest_type;
run;
proc sort data = car_communities_mod;
  by forest_type;
run;

data car_communities_mod;
  merge car_communities_mod(in=in) forest_type;
  by forest_type;
  if not in then delete;
run;

data car_communities_temp(drop = part1 part2 len );
  set car_communities_mod;
  section_ren = 'S_' || section;
  /*fixing various grouping errors by CAR*/
  /*
  if supersection_name = 'Laurentian Mixed Forest MN & Ontario Lake Plain' then do;
     len = length('Laurentian Mixed Forest Western Superior & Lake Plains');
     part1 = substr(community,1,len);
	 part2 = substr(community,len+1);
	 if part1 = 'Laurentian Mixed Forest Western Superior & Lake Plains' then 
	    community = trim(supersection_name) || trim(part2);
  end;
  */
  if community = 'Sierra Pinyon and Juniper Woodland' then 
     community = 'Sierra Pinyon / Juniper Woodland';

  if supersection_name = 'Ozark Broadleaf Forest-Meadow Boston Mountains' then do; 
	if section_ren = 'S_M231A' then supersection_name = 'Ouachita Mixed Forest-Meadow Ouachita Mountains';
	if section_ren = 'S_M223A' and fortypcd = 161 then community = 'Ozark Broadleaf Forest-Meadow Boston Mountains Loblolly-Shortleaf';
  end;

  if supersection_name = 'Central Interior Broadleaf Forest Western Low Plateau' then do;
     /*fortypcd 506 appears in two communities. One community (Central Interior Broadleaf Forest Western Low 
       Plateau Cove Forest) only has only this forest type. All foresttype within one supersection
       have to be assigned to the same community.*/
     if fortypcd = 506 and community ='Central Interior Broadleaf Forest Western Low Plateau Oak-Hickory' then delete;
  end;
  if supersection_name = 'Gulf Coastal Plain' then do;
	    /*there are five ecosection within this supersection. Four of them have fortypcd 605 assigned to one community and 
	     one ecosection has fortypcd assigned to a different community. All forestype within one supersection
	     have to be assigned to the same community.*/
	    if fortypcd = 605 then community = 'Gulf Coastal Plain Cypress & Swamp Hardwood';
  end;

   if supersection_name = 'Lower New England - Northern Appalachia' then do;
	    /*there are three ecosection within this supersection. Two of them have fortypcd 513 assigned to one community and 
	     one ecosection has fortypcd assigned to a different community. All forestype within one supersection
	     have to be assigned to the same community.*/
	   if fortypcd = 513 then community = 'Lower New England - Northern Appalachia Oak-Hickory';

	    /*there are three ecosection within this supersection. Two of them have fortypcd 999 assigned to one community and 
	     one ecosection has fortypcd assigned to a different community. All forestype within one supersection
	     have to be assigned to the same community.*/
	   if fortypcd = 999 then community = 'Lower New England - Northern Appalachia Northern Conifer';

	    /*there are four ecosection within this supersection. Four of them have fortypcd 519 assigned to one community and 
	     one ecosection has fortypcd assigned to a different community. All forestype within one supersection
	     have to be assigned to the same community.*/
	   if fortypcd = 519 then community = 'Lower New England - Northern Appalachia Oak-Hickory';
  end;

  if supersection_name = 'MW Broadleaf Forest Driftless & Morainal' then do;
	    /*there are three ecosection within this supersection. Two of them have fortypcd 171 assigned to one community and 
	     one ecosection has fortypcd assigned to a different community. All forestype within one supersection
	     have to be assigned to the same community.*/
	   if fortypcd = 171 then community = 'MW Broadleaf Forest Driftless & Morainal Pine Forests';
  end;

  if supersection_name = 'Arizona-Nevada Mountains' then do;
  /*CAR had not used the supersection for this, but rather the individual ecosection.
  */
     supersection_name = section_name;
	 community_temp = trim(supersection_name) || ', ' || strip(substr(community, lengthc("Arizona-Nevada")+1));
	 community = community_temp;
  end;

  if supersection_name = 'Aroostook-Maine-New Brunswick Hills and Lowlands' then do;
  /*CAR had not used the supersection for this, but rather the individual ecosection.
  */
     supersection_name = section_name;
	 community_temp = trim(supersection_name) || ', ' || strip(substr(community, lengthc("Aroostook-Maine-New Brunswick Hills and Lowlands")+1));
	 community = community_temp;
  end;

  if supersection_name = 'Northern California Coast' then do;
  /*CAR had not used the supersection for this, but rather the individual ecosection.
  */
     supersection_name = section_name;
	 community_temp = trim(supersection_name) || ', ' || community;
	 community = community_temp;
  end;
  if supersection_name = 'Prairie Parkland North Central Plains' then do;
  /* Non-stocked was the only forest type mapped to oak-pine. Non-stocked is now mapped to oak-hickory and oak-pine will be eliminated.
  */
     if fortypcd = 999 then community = "Prairie Parkland North Central Plains Oak-Hickory";
  end;

run;


data eco_ref;
  set eco.eco_ref;
  section_ren = 'S_' || section;
  subsection_ren = 'ES_' || subsection;
run;

proc sort data=eco_ref;
  by section_ren subsection_ren;
run;

data eco_ref;
  set eco_ref;
  retain subsection_num 0 section_num 0;
  by section_ren subsection_ren;

  if first.section_ren then section_num =section_num+1;
  if first.subsection_ren then subsection_num =subsection_num+1;

run;

proc sql;
  create table eco_ref_sum as
    select distinct section, section_num, section_ren, subsection, subsection_num,subsection_ren
	  from eco_ref
	    order by section, section_num, subsection, subsection_num
		;
quit;



proc sql;
  create table car_communities as
    select distinct car.section_ren, car.section, car.section_name, eco.section_num, forest_type,ft.value as fortypcd, community, supersection_name
	  from car_communities_temp as car,
		   eco.ref_forest_type as ft,
		   eco_ref_sum as eco
		   where car.forest_type = ft.meaning and
		         car.section_ren = eco.section_ren
		         
	  ;
quit;



proc sql;
  create table car_supersection as
    select distinct supersection_name, car.section_ren
	  from car_communities_temp as car
	    group by supersection_name
	  ;
quit;

proc sql;
  create table car_supersection_fortyp as
    select distinct supersection_name, c.fortypcd, 1 as in_data
	  from car_supersection as car,
	       sas.plot as p,
	       sas.cond as c
		   where p.cn = c.plt_cn and
			     p.section_ren = car.section_ren and
			      c.cond_status_cd = 1 and
				  c.owngrpcd = 40
				  group by supersection_name;
quit;

proc sql;
  create table car_supersection_car_fortyp as
    select distinct supersection_name, fortypcd, 1 as in_car
	  from car_communities
	    group by supersection_name;
quit;

/*checking if there are any forest types in the data that are not in the crosswalk*/
data comb;
  merge car_supersection_car_fortyp car_supersection_fortyp;
  by supersection_name;
  if in_car then delete;
run;



proc sql;
   create table cp as
     select supersection_name, community, siteclcd, cond_prop_site, sum(cond_prop_site) as cond_prop_tot
	   from (
       select car.supersection_name, car.community, c.siteclcd, sum(c.condprop_unadj) as cond_prop_site
	     from sas.plot as p,
	        sas.cond as c,
			car_communities as car
			where p.cn = c.plt_cn and
			      p.section_ren = car.section_ren and
				  car.fortypcd = c.fortypcd and
			      c.cond_status_cd = 1 and
				  c.owngrpcd = 40
         group by car.supersection_name, car.community, c.siteclcd
		 )
		 group by supersection_name, community;
quit;


/*
proc sort data = cp;
  by community siteclcd;
run;

data cp;
  set cp;
  retain proportion_below 0;
  by community;
  if first.community then do;
     proportion_below = 0;
  end;

  proportion_below = proportion_below + cond_prop_site;
  
  if proportion_below >= 0.5 * cond_prop_tot then break_below = siteclcd;
  
run;


proc sort data = cp;
  by community descending siteclcd;
run;

data cp;
  set cp;
  retain proportion_above 0;
  by community;
  if first.community then do;
     proportion_above = 0;
  end;


  proportion_above = proportion_above + cond_prop_site;
  
  if proportion_above >= 0.5 * cond_prop_tot then break_above = siteclcd;
  
run;
*/


proc sql;
  create table cp_supersection_break as
	  select supersection_name, community, site, proportion, sum(proportion) as total_proportion
	    from
		   (
		    select supersection_name, community, site, sum(cond_prop_site) as proportion
			  from (
				    select community, supersection_name, siteclcd, case when siteclcd <= &threshold. then 'high' else 'low ' end as site, cond_prop_site
				       from cp
						  group by community, supersection_name, siteclcd
					)
			 group by supersection_name, community, site
			)
	   group by supersection_name, community
		 ;
quit;

data cp_supersection_break;
  set cp_supersection_break;
  if proportion < 30 or (total_proportion - proportion) < 30 then site = 'all ';
run;


proc sql;
  create table cp_supersection_break_grouping as
    select supersection_name, community, site, sum(proportion) as cond_prop_group
	  from cp_supersection_break
	     group by supersection_name, community, site;
quit;

data cp_supersection_break_grouping;
  set cp_supersection_break_grouping;
  by supersection_name community site;
  retain group 0;
  if first.community then group = 1;
  else group = 2;
  if      site = 'low'  then do; min_siteclcd = &threshold. +1; max_siteclcd = 7;           end;
  else if site = 'high' then do; min_siteclcd = 1;              max_siteclcd = &threshold.; end;
  else                       do; min_siteclcd = 1;              max_siteclcd = 7;           end;
run;

/*
proc sql;
  create table tabling_rest_supersection as
     select distinct cp.supersection_name, cp.community, cp.group, cp.site,
	       ("b.community='" ||left(trim(cp.community)) ||"' & b.group=" || put(cp.group,1.0))  as rest,
   	       (left(trim(car.community)) ||", site class " || put(min_siteclcd,1.0) ||  " to " || put(max_siteclcd,1.0)) as descr,
		   cp.cond_prop_group
	   from cp_supersection_break_grouping as cp,
			car_communities as car
			where cp.community = car.community	        
	   group by cp.supersection_name, cp.community, cp.group;
quit;

*/




proc sql;
  create table tabling_section_temp as
     select distinct cp.supersection_name, car.section_ren
	   from cp_supersection_break_grouping as cp,
			car_communities as car
			where cp.community = car.community	        
	   group by cp.supersection_name, car.section_ren;
quit;

data tabling_section(drop = section_ren);
  set tabling_section_temp;
  by supersection_name section_ren;
  length rest_table $ 10000;
  retain rest_table "";

  if first.supersection_name then rest_table = 'c.section_ren in ("' || strip(section_ren) || '"';
  else rest_table = trim(rest_table) || ',"' || strip(section_ren) || '"';

  if last.supersection_name then do;
    rest_table = trim(rest_table) || ")";
	output;
  end;
run;


proc sql;
  create table tabling_rest_supersection_temp as
     select distinct cp.supersection_name, cp.community, cp.site, car.fortypcd,
		   cp.cond_prop_group
	   from cp_supersection_break_grouping as cp,
			car_communities as car
			where cp.community = car.community	        
	   group by cp.supersection_name, cp.community, cp.site;
quit;

data tabling_rest_supersection(drop = fortypcd);
  set tabling_rest_supersection_temp;
  length rest $ 10000;
  retain rest "";
  by supersection_name community site;
  if first.site then rest = "c.fortypcd in (" || left(fortypcd);
  else rest = trim(rest) || ", " || left(fortypcd);
  if last.site then do;
	 if site = 'all' then do;
       rest = trim(rest) || ")";
	   descr = left(trim(community)) ||", site class 1-7";
	   siteclass = "1-7";
	 end;
	 else if site = 'high' then do;
       rest = trim(rest) || ") and c.siteclcd <= &threshold.";
	   descr = left(trim(community)) ||", site class 1-&threshold.";
	   siteclass = "1-&threshold.";
	 end;
	 else if site = 'low' then do;
       rest = trim(rest) || ") and c.siteclcd > &threshold.";
	   descr = left(trim(community)) ||", site class %eval(&threshold.+1)-7";
	   siteclass = "%eval(&threshold.+1)-7";
	 end;
	 
	 output;
  end;

run;

%put "&work_dir.\tabling_rest_supersection.xlsx";

proc export data= tabling_rest_supersection
            DBMS=EXCEL2003 
            REPLACE
     file="&work_dir.\tabling_rest_supersection.xlsx";
RUN;

