libname sas "C:\Users\okuegler\Documents\nims\2013\FIADB\National\SAS";


/*Get the evalid for each ecosection*/

proc sql;
  create table ecosection_evalid as
    select distinct ppsa.evalid, p.section_ren
	  from sas.plot as p,
	       sas.pop_plot_stratum_assgn as ppsa
		   where p.cn = ppsa.plt_cn
		   order by ppsa.evalid, p.section_ren;
quit;

proc sql;
  create table supersection_evalid as
    select distinct car.supersection_name, e.evalid
	  from ecosection_evalid as e,
	       car_communities as car
		   where car.section_ren = e.section_ren
		   order by car.supersection_name, e.evalid;
quit;

data supersection_evalid_sum(drop = evalid);
   set supersection_evalid;
   length group_evalid $400;
   retain group_evalid "";
   by supersection_name evalid;

   if first.supersection_name then do;
     group_evalid = left(trim(put(evalid, 8.)));
   end;
   else do;
     group_evalid = left(trim(group_evalid)) ||  left(trim(put(evalid, 8.)));
   end;
   if last.supersection_name then do;
      supersection_filename = translate(supersection_name, '--','/\');
      output;
   end;
   else do;
      group_evalid = left(trim(group_evalid)) || ',';
   end;
run;

proc sql noprint;
  select count(supersection_name) into :num_supersection
    from supersection_evalid_sum
	;
quit;

%let num_supersection = %left(&num_supersection.);
	  

proc sql noprint;
  select supersection_name, supersection_filename 
    into :supersection1-:supersection&num_supersection.,
	     :supersection_filename1-:supersection_filename&num_supersection.
       from supersection_evalid_sum
	;
quit;
