
%macro estimation_scripts(supersection_name, supersection_filename, output_dir);

proc sql noprint;
    select count(rest) 
           into :num_row
		from tabling_rest_supersection
        where supersection_name = "&supersection_name.";
        ;
quit;

proc sql noprint;
    select rest_table
           into :rest_table
		from tabling_section
        where supersection_name = "&supersection_name.";
        ;
quit;

%let num_row = %left(&num_row.);
%put &num_row.;

proc sql noprint;
    select rest ,descr 
           into :temp_rest1 - :temp_rest&num_row.,
	            :row_description1 - :row_description&num_row.
		from tabling_rest_supersection
        where supersection_name = "&supersection_name.";
quit;

%do i=1 %to &num_row.;
   %let row_rest&i.x = &&temp_rest&i.;
   %let row_rest&i.y = &&temp_rest&i.;
   %let row_group&i. = 1;
%end;
%let max_row_num=&num_row.;
%let restrictionsx=c.cond_status_cd=1 & c.owngrpcd=40 & t.statuscd=1 & %trim(&rest_table.) ;
%let restrictionsy=c.cond_status_cd=1 & c.owngrpcd=40 & %trim(&rest_table.) ;

%let ratio_y_n = 1;

%let delete_empty_row=0;;
%let delete_empty_col=0 ;

%let variable_desc1=Board feet ;
%let variable1x=t.volbfnet ;
%let variable1y=AREA ;
%let variable_desc2=Biomass ;
%let variable2x=t.drybiot / 2000 ;
%let variable2y=t.drybiot / 2000;
%let variable_desc3=Basal Area ;
%let variable3x=t.basal_area ;
%let variable3y=t.basal_area ;
%let variable_desc4=Carbon ;
%let variable4x=t.carbon_ag/ 2000 ;
%let variable4y=t.carbon_ag / 2000 ;
%let variable_desc5=CO2 ;
%let variable5x=t.carbon_ag / 2000 * 0.90718474*44/12 ;
%let variable5y=t.carbon_ag / 2000 * 0.90718474*44/12 ;

%let MAX_VARIABLE_OF_INTEREST= 5;
%let units=1;

%let rtf_location=&supersection_filename..xlsx ;

/*
%let add_tablex=work.cp_supersection_break_grouping as b,work.car_communities as car ;

%let add_connectionx=c.section_ren=car.section_ren & car.fortypcd=c.fortypcd & b.community=car.community & b.siteclcd=c.siteclcd ;

%let add_tabley=work.cp_supersection_break_grouping as b,work.car_communities as car ;

%let add_connectiony=c.section_ren=car.section_ren & car.fortypcd=c.fortypcd & b.community=car.community & b.siteclcd=c.siteclcd ;
*/
%let add_tablex= ;
%let add_connectionx= ;
%let add_tabley= ;
%let add_connectiony= ;

%let col=0;

%let col =%eval(&col.+1);
%let col_description&col.=Board feet (bf) ;
%let col_group&col.=1 ;
%let col_format&col.= ;
%let col_width_se&col.= ;
%let col_rest&col.x=1 ;
%let col_var&col.x=1 ;
%let col_rest&col.y=1 ;
%let col_var&col.y=1 ;

%let col =%eval(&col.+1);
%let col_description&col.=Biomass (tons) ;
%let col_group&col.=1 ;
%let col_format&col.= ;
%let col_width_se&col.= ;
%let col_rest&col.x=1 ;
%let col_var&col.x=2 ;
%let col_rest&col.y=1 ;
%let col_var&col.y=1 ;

%let col =%eval(&col.+1);
%let col_description&col.=Basal area (sq. feet) ;
%let col_group&col.=1 ;
%let col_format&col.= ;
%let col_width_se&col.= ;
%let col_rest&col.x=1 ;
%let col_var&col.x=3 ;
%let col_rest&col.y=1 ;
%let col_var&col.y=1 ;

%let col =%eval(&col.+1);
%let col_description&col.=Carbon (short tons) ;
%let col_group&col.=1 ;
%let col_format&col.= ;
%let col_width_se&col.= ;
%let col_rest&col.x=1 ;
%let col_var&col.x=4 ;
%let col_rest&col.y=1 ;
%let col_var&col.y=1 ;

%let col =%eval(&col.+1);
%let col_description&col.=CO2 (metric tons) ;
%let col_group&col.=1 ;
%let col_format&col.= ;
%let col_width_se&col.= ;
%let col_rest&col.x=1 ;
%let col_var&col.x=5 ;
%let col_rest&col.y=1 ;
%let col_var&col.y=1 ;

%let max_col_num=&col.;

%let title=&supersection_name.;
%let title2=(per acre) ;
%let row_group_name1= ;
%let number_of_digits=2 ;


%save_table_def(&output_dir.\&supersection_filename..sas);

%mend;



%macro create_scripts;
%do j=1 %to &num_supersection.;
   %put &j. &&supersection&j.;
   %estimation_scripts(&&supersection&j., &&supersection_filename&j., &script_dir.);
%end;
%mend;

%create_scripts;


