libname eco "&work_dir.\eco.accdb";
libname sas "C:\Users\okuegler\Documents\nims\2013\FIADB\National\SAS";
%include "&work_dir.\tabling_program\run_tabeling.sas";
	
%let script_dir=&work_dir.\SAS_supersection;
%let result_dir=&work_dir.\results_supersection;

%include "&work_dir.\import_data.sas";	
%get_data;


proc datasets library = work;
     delete access_output;
   run;
quit;

%macro run_super(num)/ MINOPERATOR mindelimiter=',';
%let rtf_dir=&result_dir.;
%let display_tables=2;

%do j=1 %to &num.;;
   %include "&script_dir.\&&supersection_filename&j...sas" /LRECL= 5000;
   data group_evalid(keep = evalid_group evalid evaldescr group_evaldescr same_group);
	 set supersection_evalid(where = (supersection_name =  "&&supersection&j."));
     length group_evaldescr $200.;
	 group_evaldescr = "&&supersection_filename&j.";
	 evaldescr = "&&supersection_filename&j.";
	 evalid_group = 1;
	 same_group = 1;
   run;

    proc sql noprint;
      select distinct evalid, evaldescr
        into :evalid separated by ',', :evaldesc separated by '|'
        from group_evalid
        ;
    quit;

    proc sql noprint;
      select distinct group_evaldescr, evalid_group
        into :group_evaldescr separated by '|',
             :evalid_group separated by ','
        from group_evalid
        ;
    quit;


/*    %if 6 in (&evalid.) or 4 in (&evalid.) or 5 in (&evalid.) %then %do;*/
	   %put &j. &&supersection&j.;
       %run_programs;
/*	%end;*/
%end;
%mend;

%run_super(&num_supersection.);

/*%run_super(2);*/

   proc export data = access_output(drop = extra_row row_group_num row_format row_run empty success id)
     outtable = "output"
	 dbms=access
	 label
	 replace
	 ;
	 database="&work_dir.\output.accdb";
   run;
