/*%macro xls_print(indy9);
*/

%macro access_print;
/*
%if %upcase("%substr(&rtf_location.,%eval(%length(&rtf_location.)-2),3)")="XLS" %then %do;
   %let base_outfile=%substr(&rtf_location.,1,%eval(%length(&rtf_location.) - 4));
%end;
  %else %let base_outfile=&rtf_location.;
*/

%let evalid_num_run = 0;


%do i=1 %to 500;
  %let old_row_format&i. = &&row_format&i.;
%end;

%if &display_tables. ne 1 %then %do;
  data _null_;
    length file $400.;
    howmany = countc("&rtf_location.",'\');
    file = scanq("&rtf_location.",howmany+1,'\');
	/*
	if length("&rtf_location.") > length(file)) then do;
       dir = substr("&rtf_location.",1,length("&rtf_location.") - length(file));
       call symput("xls_dir",trim(left(dir)));
	end;
    */

    if not((upcase(substr("&rtf_location.",length("&rtf_location.")-2)) eq "XLS") or
	   (upcase(substr("&rtf_location.",length("&rtf_location.")-3)) eq "XLSX")) then
      call cats(file,'.xls');
    call symput("xls_file",trim(left(file)));
  run;
%end;



%if (%substr(&rtf_dir.,%length(&rtf_dir.)) ne \) %then
     %let rtf_dir = %trim(&rtf_dir.)\;
%let xls_dir=&rtf_dir.;


%do col_run=1 %to &max_col_num.;
   %let col_description&col_run. = %sysfunc(compress(&&col_description&col_run., '().'));
   %let variable_desc1 = %sysfunc(compress(&&variable_desc1., '().'));
%end;

%do %until (%scan(%bquote(&evalid_group.), &evalid_num_run.+1,',') eq );
  %let evalid_num_run = %sysevalf(&evalid_num_run.+1);
  %let evalid_curr = %scan(%bquote(&evalid_group.), &evalid_num_run.,',');
/*%put &evalid_curr;*/

/*%if &variable_direction.=1 %then %do;*/
  %do i=1 %to 500;
     %let row_format&i. =&&old_row_format&i.;
  %end;

   data evalid_&evalid_curr.;
   run;


  data evalid_&evalid_curr. (keep = row_group_num row_format empty row_name extra_row row_run
                           %do row_run=1 %to &max_row_num.;
                             %do col_run=1 %to &max_col_num.;
                                   col_%eval(100*&col_run +1)
								   col_std_%eval(100*&col_run +1)
								   %if &count_plots_non_zero.=1 %then %do;
								     col_num_%eval(100*&col_run +1)
								   %end;
							  %end;
							%end;);


  set estimation(where=(evalid_group = &evalid_curr.));
  retain last_row_group_num 0;
  length row_name $ 200;
  extra_row = 0;

  label row_name="&row_var_name_out. ";
  %do col_run=1 %to &max_col_num.;
	   label
/*         col_%eval(100*&col_run +1) = "&&col_description&col_run. x &&variable_desc1"*/
/*	     col_std_%eval(100*&col_run +1) = "Std &&col_description&col_run.*&&variable_desc1";*/
         col_%eval(100*&col_run +1) = "&&col_description&col_run."
	     col_std_%eval(100*&col_run +1) = "Std &&col_description&col_run.";
    %if &count_plots_non_zero.=1 %then %do;
/*          label col_num_%eval(100*&col_run.+1) = "&&col_description&col_run.*&&variable_desc1 ";*/
          label col_num_%eval(100*&col_run.+1) = "&&col_description&col_run.";
	%end;

       format col_%eval(100*&col_run +1) comma14.&number_of_digits.
	          col_std_%eval(100*&col_run +1) comma10.&number_of_digits.;
    %if &count_plots_non_zero.=1 %then %do;
	   format col_num_%eval(100*&col_run.+1) comma8.&number_of_digits.;
	%end;
	          
  %end;


  %do row_run=1 %to &max_row_num.;
    %if "&&row_group&row_run." = "" %then %do;
	   %let row_group&row_run.=last_row_group_num;
	%end;

    row_group_num =&&row_group&row_run.;

	if row_group_num < last_row_group_num then row_group_num = last_row_group_num;
	last_row_group_num = row_group_num;

    row_format ="&&row_format&row_run.    ";
	row_run = &row_run.;

	row_name = "&&row_description&row_run. ";
	empty = 0;
    %do col_run=1 %to &max_col_num.;
          col_%eval(100*&col_run +1) = r_c_&row_run._&col_run.;
          col_std_%eval(100*&col_run +1) = std_r_c_&row_run._&col_run.;
		  %if &count_plots_non_zero.=1 %then %do;
            col_num_%eval(100*&col_run +1) = r_c_num_&row_run._&col_run.;
		  %end;
		  if abs(col_%eval(100*&col_run +1)*&units.) > %sysevalf(&rounding_threshold. ) then
		    empty = empty + abs(col_%eval(100*&col_run +1));
    %end;
	if empty > 0 then empty = 0;
	else empty = 1;
	output;
	row_run = .;
    %if "&&extra_row&row_run." ne "" %then %do;
      row_group_num =&&row_group&row_run.;

	  if row_group_num < last_row_group_num then row_group_num = last_row_group_num;
	  last_row_group_num = row_group_num;

      row_format ="    ";
	  row_name = "&&extra_row_note&row_run.";
	  extra_row = &&extra_row&row_run.;
      %do col_run=1 %to &max_col_num.;
          col_%eval(100*&col_run +1) = 0;
          col_std_%eval(100*&col_run +1) = 0;
		  %if &count_plots_non_zero.=1 %then %do;
            col_num_%eval(100*&col_run +1) = 0;
		  %end;
      %end;
	  empty = .;
	  output;
	  extra_row=0;
	%end;

  %end;
  run;


proc sql noprint;
    select %do i=1 %to &max_col_num.;
 		  (case when max(abs(col_%eval(100*&i.+1)))>0 then 0 else 1 end)
		    %if &i. lt &max_col_num. %then ,;
		  %end;
		into %do i=1 %to &max_col_num.;
 		     :empty_col&i 
		         %if &i. lt &max_col_num. %then ,;
		      %end;
		from evalid_&evalid_curr.;
quit;


proc sql noprint;
    select empty
	    into :empty_row1 - :empty_row&max_row_num.
		from evalid_&evalid_curr.
           where empty ne .;
quit;

proc sql noprint;
    select min(empty)
	    into :empty_row_group1 - :empty_row_group&max_row_group_num.
		from evalid_&evalid_curr.
           where empty ne .
              group by row_group_num;
quit;


proc sql noprint;
  select 
    %if &max_col_num. >1 %then %do;
      int(log10(max(max( 
      %do i=1 %to &max_col_num.-1;
        abs(col_%eval(100*&i.+1)),
	  %end;
	  abs(col_%eval(100*&max_col_num.+1))
      )))+1 + &number_of_digits.),
      int(log10(max(max( 
      %do i=1 %to &max_col_num.-1;
        abs(col_std_%eval(100*&i.+1)),
	  %end;
	  abs(col_std_%eval(100*&max_col_num.+1))
      )))+1 + &number_of_digits.)
      %end;
      %else %do;
	    int(log10(max(abs(col_%eval(100*&max_col_num.+1))))+1 + &number_of_digits.),
	    int(log10(max(abs(col_std_%eval(100*&max_col_num.+1))))+1 + &number_of_digits.)
      %end;

    into :digit_col, 
         :digit_col_std
    from evalid_&evalid_curr. e
  ;
quit;





data evalid_&evalid_curr.(drop = 
						  %do i=1 %to &max_col_num.;
						     %if &&empty_col&i. = 1 & &delete_empty_row. = 1 %then %do;
							   col_%eval(100*&i.+1) col_std_%eval(100*&i.+1)
							 %end;
						  %end;
					      );
  set evalid_&evalid_curr.;
  if empty = 1 and &delete_empty_row. = 1 then do;
     row_format = compress(row_format || 'd');
	 %do i=1 %to &max_row_num.;
	   if row_run eq &i. and %index(&&row_format&i.,d) eq 0 then do;
         call symput(trim('row_format' || left(row_run)),row_format);
		 success = 1;
	   end;
	 %end;
  end;
run;

data evalid_&evalid_curr.;
  set evalid_&evalid_curr.;
  id = _n_;
run;


%if (%sysfunc(exist(work.access_output))) %then %do;
   proc append base=access_output
        data= evalid_&evalid_curr.;
   run;
%end;
%else %do;
   data access_output; 
     set evalid_&evalid_curr.;
   run;
%end;


%end;



%do i=1 %to 500;
     %let row_format&i. =&&old_row_format&i.;
%end;

%mend;

/*
%access_print;
*/
