/*%macro xls_print(indy9);
*/
%macro xls_print;
/*
%if %upcase("%substr(&rtf_location.,%eval(%length(&rtf_location.)-2),3)")="XLS" %then %do;
   %let base_outfile=%substr(&rtf_location.,1,%eval(%length(&rtf_location.) - 4));
%end;
  %else %let base_outfile=&rtf_location.;
*/

%let evalid_num_run = 0;


%do i=1 %to 500;
  %let old_row_format&i. = &&row_format&i.;
%end;

%if &display_tables. ne 1 %then %do;
  data _null_;
    length file $400.;
    howmany = countc("&rtf_location.",'\');
    file = scanq("&rtf_location.",howmany+1,'\');
	/*
	if length("&rtf_location.") > length(file)) then do;
       dir = substr("&rtf_location.",1,length("&rtf_location.") - length(file));
       call symput("xls_dir",trim(left(dir)));
	end;
    */

    if not((upcase(substr("&rtf_location.",length("&rtf_location.")-2)) eq "XLS") or
	   (upcase(substr("&rtf_location.",length("&rtf_location.")-3)) eq "XLSX")) then
      call cats(file,'.xls');
    call symput("xls_file",trim(left(file)));
  run;
%end;

%if (%substr(&rtf_dir.,%length(&rtf_dir.)) ne \) %then
     %let rtf_dir = %trim(&rtf_dir.)\;
%let xls_dir=&rtf_dir.;


%do %until (%scan(%bquote(&evalid_group.), &evalid_num_run.+1,',') eq );
  %let evalid_num_run = %sysevalf(&evalid_num_run.+1);
  %let evalid_curr = %scan(%bquote(&evalid_group.), &evalid_num_run.,',');
/*%put &evalid_curr;*/

/*%if &variable_direction.=1 %then %do;*/
  %do i=1 %to 500;
     %let row_format&i. =&&old_row_format&i.;
  %end;

   data evalid_&evalid_curr.;
   run;


  data evalid_&evalid_curr. (keep = row_group_num row_format empty row_name extra_row row_run
                           %do row_run=1 %to &max_row_num.;
                             %do col_run=1 %to &max_col_num.;
                                   col_%eval(100*&col_run +1)
								   col_std_%eval(100*&col_run +1)
								   %if &count_plots_non_zero.=1 %then %do;
								     col_num_%eval(100*&col_run +1)
								   %end;
							  %end;
							%end;);


  set estimation(where=(evalid_group = &evalid_curr.));
  retain last_row_group_num 0;
  length row_name $ 200;
  extra_row = 0;

  label row_name="&row_var_name_out. ";
  %do col_run=1 %to &max_col_num.;
	   label
         col_%eval(100*&col_run +1) = "&&col_description&col_run.*&&variable_desc1 " 
	     col_std_%eval(100*&col_run +1) = "Std.";
    %if &count_plots_non_zero.=1 %then %do;
          label col_num_%eval(100*&col_run.+1) = "&&col_description&col_run.*&&variable_desc1 ";
	%end;

       format col_%eval(100*&col_run +1) comma14.&number_of_digits.
	          col_std_%eval(100*&col_run +1) comma10.&number_of_digits.;
    %if &count_plots_non_zero.=1 %then %do;
	   format col_num_%eval(100*&col_run.+1) comma8.&number_of_digits.;
	%end;
	          
  %end;


  %do row_run=1 %to &max_row_num.;
    %if "&&row_group&row_run." = "" %then %do;
	   %let row_group&row_run.=last_row_group_num;
	%end;

    row_group_num =&&row_group&row_run.;

	if row_group_num < last_row_group_num then row_group_num = last_row_group_num;
	last_row_group_num = row_group_num;

    row_format ="&&row_format&row_run.    ";
	row_run = &row_run.;

	row_name = "&&row_description&row_run. ";
	empty = 0;
    %do col_run=1 %to &max_col_num.;
          col_%eval(100*&col_run +1) = r_c_&row_run._&col_run.;
          col_std_%eval(100*&col_run +1) = std_r_c_&row_run._&col_run.;
		  %if &count_plots_non_zero.=1 %then %do;
            col_num_%eval(100*&col_run +1) = r_c_num_&row_run._&col_run.;
		  %end;
		  if abs(col_%eval(100*&col_run +1)*&units.) > %sysevalf(&rounding_threshold. ) then
		    empty = empty + abs(col_%eval(100*&col_run +1));
    %end;
	if empty > 0 then empty = 0;
	else empty = 1;
	output;
	row_run = .;
    %if "&&extra_row&row_run." ne "" %then %do;
      row_group_num =&&row_group&row_run.;

	  if row_group_num < last_row_group_num then row_group_num = last_row_group_num;
	  last_row_group_num = row_group_num;

      row_format ="    ";
	  row_name = "&&extra_row_note&row_run.";
	  extra_row = &&extra_row&row_run.;
      %do col_run=1 %to &max_col_num.;
          col_%eval(100*&col_run +1) = 0;
          col_std_%eval(100*&col_run +1) = 0;
		  %if &count_plots_non_zero.=1 %then %do;
            col_num_%eval(100*&col_run +1) = 0;
		  %end;
      %end;
	  empty = .;
	  output;
	  extra_row=0;
	%end;

  %end;
  run;


proc sql noprint;
    select %do i=1 %to &max_col_num.;
 		  (case when max(abs(col_%eval(100*&i.+1)))>0 then 0 else 1 end)
		    %if &i. lt &max_col_num. %then ,;
		  %end;
		into %do i=1 %to &max_col_num.;
 		     :empty_col&i 
		         %if &i. lt &max_col_num. %then ,;
		      %end;
		from evalid_&evalid_curr.;
quit;


proc sql noprint;
    select empty
	    into :empty_row1 - :empty_row&max_row_num.
		from evalid_&evalid_curr.
           where empty ne .;
quit;

proc sql noprint;
    select min(empty)
	    into :empty_row_group1 - :empty_row_group&max_row_group_num.
		from evalid_&evalid_curr.
           where empty ne .
              group by row_group_num;
quit;


proc sql noprint;
  select 
    %if &max_col_num. >1 %then %do;
      int(log10(max(max( 
      %do i=1 %to &max_col_num.-1;
        abs(col_%eval(100*&i.+1)),
	  %end;
	  abs(col_%eval(100*&max_col_num.+1))
      )))+1 + &number_of_digits.),
      int(log10(max(max( 
      %do i=1 %to &max_col_num.-1;
        abs(col_std_%eval(100*&i.+1)),
	  %end;
	  abs(col_std_%eval(100*&max_col_num.+1))
      )))+1 + &number_of_digits.)
      %end;
      %else %do;
	    int(log10(max(abs(col_%eval(100*&max_col_num.+1))))+1 + &number_of_digits.),
	    int(log10(max(abs(col_std_%eval(100*&max_col_num.+1))))+1 + &number_of_digits.)
      %end;

    into :digit_col, 
         :digit_col_std
    from evalid_&evalid_curr. e
  ;
quit;





data evalid_&evalid_curr.(drop = 
						  %do i=1 %to &max_col_num.;
						     %if &&empty_col&i. = 1 & &delete_empty_row. = 1 %then %do;
							   col_%eval(100*&i.+1) col_std_%eval(100*&i.+1)
							 %end;
						  %end;
					      );
  set evalid_&evalid_curr.;
  if empty = 1 and &delete_empty_row. = 1 then do;
     row_format = compress(row_format || 'd');
	 %do i=1 %to &max_row_num.;
	   if row_run eq &i. and %index(&&row_format&i.,d) eq 0 then do;
         call symput(trim('row_format' || left(row_run)),row_format);
		 success = 1;
	   end;
	 %end;
  end;
run;

data evalid_&evalid_curr.;
  set evalid_&evalid_curr.;
  id = _n_;
run;

/*
%if &variable_directionx.=1 %then %do;
  %let temp_var=&max_variable_of_interest.;
%end;
%else %do;
  %let temp_var=1;
%end;
*/
%let temp_var=1;


proc sql noprint;
  select group_evaldescr
    into :sheet_name
	  from group_evalid
	  where evalid_group = &evalid_curr.
	  ;
quit;

%let title_name = &sheet_name.;
%let evaldescr_curr = &sheet_name.;

%let tab_length_name = 30;

data _null_;
  sheet_name=compress("%substr(%bquote(&sheet_name.),1,&tab_length_name.)",":");
  call symput('sheet_name',sheet_name);
run;


%if &display_tables.=1 %then %do;

proc print data = evalid_&evalid_curr.(where=(not(id in (&exclude_row.)))) split='*' noobs;
var row_name 
  %if &variable_directionx.=2 %then %do;
    variable_name
  %end;
  %let run_exclude=1;
  %do col_run=1 %to &max_col_num.;
    %do var_run=1 %to &temp_var.;
	  %if %not_in(&run_exclude.,&exclude_col.) %then %do;
	    col_%eval(100*&col_run +&var_run.) col_std_%eval(100*&col_run +&var_run.)
	  %end;
	  %let run_exclude=%eval(&run_exclude.+1);
    %end;
  %end;
  ;
  title1 "&title_name. ";
  title2 "&evaldescr_curr. ";
  title3 &title2.;
run;

%end;
%else %if &display_tables.=2 %then %do;
/*Export tables to the Excel spredsheet*/
/*
X '"C:\Program Files\Microsoft Office\Office\excel.exe" ';
data _null_;
  x=sleep(3);
run;
OPTIONS XWAIT;
*/

/*Start Excel. This does not work in Windows 95. Use the above statement in 95*/
options noxsync noxwait;
filename sas2xl dde 'excel|system';
data _null_;
  length fid rc start stop time 8;
  fid=fopen('sas2xl','s');
  if (fid le 0) then do;
    rc=system('start excel');
    start=datetime();
    stop=start+10;
    do while (fid le 0);
      fid=fopen('sas2xl','s');
      time=datetime();
      if (time ge stop) then fid=1;
    end;
  end;
rc=fclose(fid);
run;

filename ddecmds dde 'excel|system'  lrecl=1048576;

%let print_title=&title.;

%do break=0 %to %eval(&num_col_break.);

%if &num_col_break = 0 %then %do;
  %let use_sheet_name=&sheet_name. ;
  %let start_col=1;
  %let end_col=&max_col_num.;
%end;
%else %do;
  %if &break.=0 %then %do;
     %let use_sheet_name=&sheet_name.;
     %if %length(&sheet_name.) + %length(&col_break_tabadd0) < &tab_length_name. %then
       %let use_sheet_length = %length(&sheet_name.);
     %else
       %let use_sheet_length=%eval(&tab_length_name. - %length(&col_break_tabadd0));

     %let use_sheet_name=%substr(%quote(&sheet_name.),1,&use_sheet_length) &col_break_tabadd0.;

     %let start_col = 1;
  %end;
  %else %do;
     %let print_title=&&col_break_title&break.;
     %let start_col = %eval(&end_col.+1);

     %if %length(&sheet_name.) + %length(&&col_break_tabadd&break.) < &tab_length_name. %then
       %let use_sheet_length = %length(&sheet_name.);
     %else
       %let use_sheet_length=%eval(&tab_length_name. - %length(&&col_break_tabadd&break.));

     %let use_sheet_name=%substr(%quote(&sheet_name.),1,&use_sheet_length) &&col_break_tabadd&break.;
  %end;

  %if &break. = %eval(&num_col_break.) %then %do;
     %let end_col = &max_col_num.;
  %end;
  %else %do;
     %let temp_break=%eval(&break.+1);
     %let end_col = &&col_break&temp_break.;
  %end;
%end;
/*
%put &start_col.;
%put &end_col.;
*/
%let cur_col_num = %eval(&end_col. - &start_col. +1);


filename ddedata dde "excel|&xls_dir.[&xls_file.]%qtrim(%bquote(&use_sheet_name.))!R1C1:R1000C%eval(3*&max_col_num.+2)" notab  lrecl=1048576;
/*
filename ddedata dde "excel|&xls_dir.[&xls_file.]%qtrim(%bquote(&sheet_name.))!R1C1:R1000C%eval(3*&max_col_num.+2)" notab  lrecl=1048576;
*/

data test;
  file ddecmds;
  fname="tempfile";
  rc=filename(fname,"&xls_dir.&xls_file.");

  if rc = 0 and fexist(fname) then do;
    if &evalid_num_run.=1 and &break.=0 then do;
       rc=fdelete(fname);
       put '[NEW(1)]';
       put "[SAVE.AS(""&xls_dir.&xls_file."")]";
	end;
    else do;
       put "[open(""&xls_dir.&xls_file."")]";
    end;
  put '[workbook.insert(1)]';
  rc=filename(fname);
  end;

  else do;
    put '[NEW(1)]';
    put "[SAVE.AS(""&xls_dir.&xls_file."")]";
  end;
  put '[workbook.next()]';
  put '[workbook.insert(3)]';
run;

filename xlmacro dde 'excel|macro1!r1c1:r1000c1' notab;
data _null_;
file xlmacro;

put "=workbook.name(""Sheet1"",""%qtrim(%bquote(&use_sheet_name.))"")";

*put "[open(""&xls_dir.&xls_file."")]";
put '=halt(true)';
put '!dde_flush';
file ddecmds;
put '[run("macro1!r1c1")]';
put '[error(false)]';
put '[workbook.activate("macro1")]';
put '[workbook.delete("macro1")]';
run;
options noxsync noxwait xmin;


proc sql;
  create table empty_row_group_name as
    select row_group_num, min(empty) as empty_group
	  from evalid_&evalid_curr.
	    group by row_group_num;
quit;



data row_group_name;
format row_group_name $100.;
%do i=1 %to &max_row_group_num.;
  row_group_num=&i;
  row_group_name="&&row_group_name&i.";
  output;
%end;
run;


data row_group_name;
  merge row_group_name empty_row_group_name;
  by row_group_num;
run;


%let table_start=3;

%let any_col_group_names = 0;
/*%do i=1 %to &max_col_num.;*/
%do i=&start_col. %to &end_col.;
	%if "&&&&col_group_name&&col_group&i." ne "" %then %let any_col_group_names = 1;
%end;
%if &any_col_group_names. = 0 %then %do;
   %let table_start=%eval(&table_start.-1);	  
%end;

/*Make sure all numbers are printed as intended and Excel doesn't change numbers to dates etc.
*/
data _null_;
  file ddecmds;
  put "[SELECT(""R1:R%eval(&table_start.+2)"")]";
  put '[format.number("@")]';
run;

*data _null_;
data test;
  file ddedata;
  merge evalid_&evalid_curr. end=last row_group_name ;
  by row_group_num; 

  length red $ 2000 orange $ 2000;
  retain k %eval(&table_start. + 3) red "" orange "";

  if first.row_group_num and row_group_name ne "" then k= k+1;
  if index(row_format,'d')>=1 then do;
    /*delete*/
    k=(k-1);
  end;
  k= k+1;
/*  k= k+ extra_row;*/

  if _n_ = 1 then do;
/*    %do i=1 %to %eval(&max_col_num.-1); */
    %do i=&start_col. %to %eval(&end_col.-1);
		%if &&empty_col&i. ne 1 or &delete_empty_col. ne 1 %then %do; 
            put '09'x '09'x '09'x @@;
		%end;
    %end;
    %if &print_date. = "1" %then %do;
       date = date(); 
	   put '09'x '09'x date mmddyy10.;
	%end;
	%else %do;
	   put;
    %end;
/*    put;*/
/*    put "&print_title., &sheet_name.";*/
    put "&print_title., &title_name.";
	
    %if &evaldescr_yes.=1 and "&evaldescr_curr." ne "" %then %do;
	  put "&evaldescr_curr. ";
	%end;
	%if "&col_var_name_out." ne "" %then %do;
	   %let table_start=%eval(&table_start. +1);
	   k = k+1;
	   put '09'x '09'x "&col_var_name_out.";
	%end;

	%if &any_col_group_names. = 1 %then %do;
      do i=1 to 2; 
        put '09'x @@;
      end;

	  %let last_col_group=-1;
/*      %do i = 1 %to &max_col_num.;*/
      %do i=&start_col. %to &end_col.;
	    %if &&empty_col&i. ne 1 or &delete_empty_col. ne 1 %then %do; 
          %if &last_col_group. ne &&col_group&i. %then %do;
	        %if "&&&&col_group_name&&col_group&i." ne "" %then %do;
	           put "&&&&col_group_name&&col_group&i. " +(-1) @@;
	           %if "&&col_group_foot&i." eq "1" %then %do; put 'B9'x @@; %end;
      	       %if "&&col_group_foot&i." eq "2" %then %do; put 'B2'x @@; %end;
      		   %if "&&col_group_foot&i." eq "3" %then %do; put 'B3'x @@; %end;
			   put '09'x '09'x '09'x @@;
		    %end;
		    %else %do;
	           put '09'x '09'x '09'x @@;
		    %end;
		    %let last_col_group=&&col_group&i.;
          %end; 
          %else %do;
	         put '09'x '09'x '09'x @@;
	      %end;
        %end;
	  %end;
      put;
    %end;

    put  '09'x '09'x @@;

/*    %do i=1 %to &max_col_num.;*/
    %do i=&start_col. %to &end_col.;
	  %if &&empty_col&i. ne 1 or &delete_empty_col. ne 1 %then %do; 
        put "&&col_description&i. " +(-1) @@;
        %if "&&col_foot&i." eq "1" %then %do; put 'B9'x @@; %end;
        %if "&&col_foot&i." eq "2" %then %do; put 'B2'x @@; %end;
        %if "&&col_foot&i." eq "3" %then %do; put 'B3'x @@; %end;
        put '09'x '09'x '09'x @@;
	  %end;
    %end;
    put;


	%if "&row_var_name_out." ne "" %then %do;
       put "&row_var_name_out. " '09'x '09'x @@;
	%end;
    %else %do;
       put  '09'x '09'x @@;
    %end;
/*    %do i=1 %to &max_col_num.;*/
    %do i=&start_col. %to &end_col.;
	  %if &&empty_col&i. ne 1 or &delete_empty_col. ne 1 %then %do; 
        %if &ratio_y_n. eq 2 %then %do;
          put "Total" '09'x "SE" '09'x '09'x @@;
        %end;
        %else %do;
          put "Mean" '09'x "SE" '09'x '09'x @@;
        %end;
	  %end;
    %end;


    put;
	put '09'x '09'x "&title2.";
  end;
  /*end of initial lines*/

  if first.row_group_num and  row_group_name ne "" then do;
    put row_group_name;
  end;
  num_indent=0;
/*
  indent=index(row_format,'t');
  indent = 0;

  if (indent>1 and anydigit(substr(row_format,indent-1,1))>0) then do;
     num_indent = int(substr(row_format,indent-1,1));
  end;

  else if indent>0 then 
     num_indent=1;

  if row_group_name="" and indent>0 then do;
    do i=1 to num_indent;
       put "    " @@;
    end;
    put row_name '09'x '09'x @@;  
	end;
  else if row_group_name="" then
    put row_name '09'x '09'x @@;  
  else if indent>0 then do;
    put '09'x @@ ;
    do i=1 to num_indent;
       put "    " @@;
    end;
	put row_name '09'x @@;
    end;
  else */
  if row_group_name="" then do;
    put row_name '09'x '09'x @@;  
  end;
  else do;
    put '09'x row_name '09'x @@;
  end;
/*  %do i=1 %to &max_col_num.;*/
  %do i=&start_col. %to &end_col.;
	%if &&empty_col&i. ne 1 or &delete_empty_col. ne 1 %then %do; 
      if abs(col_%eval(100*&i.+1)*&units.) <= %sysevalf(&rounding_threshold.) or col_%eval(100*&i.+1) = . then do;
        if extra_row = 0 then
          put '--' '09'x '--' '09'x '09'x @@;
        else
          put '09'x '09'x '09'x @@;
      end;
	  else do;
        put col_%eval(100*&i.+1) '09'x col_std_%eval(100*&i.+1) '09'x '09'x @@;
	    if abs(col_%eval(100*&i.+1)) > &red_value.*col_std_%eval(100*&i.+1) then do;
		  if red = "" then red = compress("R"|| k || "C" || (&i. - &start_col. + 1)*3);
		  else red = compress("R"|| k || "C" || (&i. - &start_col. + 1)*3) ||','||red;
	    end; 
	    else if abs(col_%eval(100*&i.+1)) > &orange_value.*col_std_%eval(100*&i.+1) then do;
		  if orange = "" then orange = compress("R"|| k || "C" || (&i. - &start_col. + 1)*3);
		  else orange = compress("R"|| k || "C" || (&i. - &start_col. + 1)*3) ||','||orange;
	    end;
	  end;
	%end;
  %end;
  call symput("redline",compress(red));
  call symput("orangeline",compress(orange));

  if last then do;
    put;
/*
	%if %bquote(&footnote.) ne "" %then %do; put "&footnote."; %end;
*/
    %if "&footnote." ne "" %then %do; put "&footnote."; %end;
    %if "&footnote1." ne "" %then %do; put 'B9'x "&footnote1."; %end;
    %if "&footnote2." ne "" %then %do; put 'B2'x "&footnote2."; %end;
    %if "&footnote3." ne "" %then %do; put 'B3'x "&footnote3."; %end;
	
  end;
  put;
run;
/*
%abort;
*/
/*
superscript:
put '[font.properties(,,,,1,,,,,,,,3,1)]';
*/


data _null_;
  file ddecmds;
  put "[workbook.activate(""%qtrim(%bquote(&use_sheet_name.))"")]";
/*change column width and some basic formating*/
  put "[SELECT(""R%eval(&table_start.+1)C1:R%eval(&table_start.+1)C%eval(2)"")]";
  put '[ALIGNMENT(2,0,1)]';

  %let extra_i = 0;
/*  %do i=1 %to &max_col_num.;*/
  %do i=&start_col. %to &end_col.;
	 %if &&empty_col&i. eq 1 and &delete_empty_col. eq 1 %then %do; 
	   %let extra_i = %eval(&extra_i. - 1);
	 %end;
     %else %do;
	   put "[SELECT(""C%eval(3*(&i. -(&start_col.-1) + &extra_i.))"")]";
	   %if "&&col_width&i." = "" %then %do;
         put "[COLUMN.WIDTH(%sysevalf(&digit_col. * 1.05 +1))]";
       %end;
       %else %do;
         put "[COLUMN.WIDTH(&&col_width&i.)]";
       %end;

       put "[SELECT(""C%eval(3*(&i. -(&start_col.-1) + &extra_i.)+1)"")]";
	   %if "&&col_width_se&i." = "" %then %do;
         put "[COLUMN.WIDTH(%sysevalf(&digit_col_std. * 1.05 +1))]";
       %end;
       %else %do;
         put "[COLUMN.WIDTH(&&col_width_se&i.)]";
       %end;

	   put "[SELECT(""R%eval(&table_start.+1)C%eval(3*(&i. -(&start_col.-1) + &extra_i.)):R%eval(&table_start.+1)C%eval(3*(&i. -(&start_col.-1) + &extra_i.)+1)"")]";
       put '[ALIGNMENT(7,1,1)]'; 
       put '[BORDER(0,0,0,0,1)]';
       put '[ROW.HEIGHT(,,,3)]';

/*       %if &i. < &max_col_num. %then %do;*/
       %if &i. < &end_col. %then %do;
         put "[SELECT(""C%eval(3*(&i. -(&start_col.-1) + &extra_i.)+2)"")]";
         put '[COLUMN.WIDTH(1)]';
	   %end;
	 %end;
  %end;
  put '[SELECT("C1:C200")]';
  put "[FORMAT.FONT(""&excel_font."", &excel_font_size.,0,0)]";
  
  %if "&col_var_name_out." ne "" %then %do;
/*     put "[SELECT(""R%eval(&table_start.-1)C%eval(3):R%eval(&table_start.-1)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";;*/
     put "[SELECT(""R%eval(&table_start.-1)C%eval(3):R%eval(&table_start.-1)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";;
     put '[ALIGNMENT(7,1)]'; 
     put '[BORDER(0,0,0,0,1)]';
     put "[FORMAT.FONT(""&excel_font."", &excel_font_size.,1,0)]";
  %end;

  put "[SELECT(""R%eval(&table_start.):R%eval(&table_start.+2)"")]";
  put "[FORMAT.FONT(""&excel_font."", &excel_font_size.,1,0)]";

/*  put "[SELECT(""R%eval(&table_start.+2)C3:R%eval(&table_start.+2)C%eval(3*(&max_col_num. + &extra_i.) + 1)"")]";*/
  put "[SELECT(""R%eval(&table_start.+2)C3:R%eval(&table_start.+2)C%eval(3*(&cur_col_num. + &extra_i.) + 1)"")]";
  put '[ALIGNMENT(4)]'; 


/*  put "[SELECT(""R%eval(&table_start.+3)C3:R%eval(&table_start.+3)C%eval(3*(&max_col_num. + &extra_i.) + 1)"")]";*/
  put "[SELECT(""R%eval(&table_start.+3)C3:R%eval(&table_start.+3)C%eval(3*(&cur_col_num. + &extra_i.) + 1)"")]";
  put "[FORMAT.FONT(""&excel_font."", &excel_font_size.,0,1)]";
  put '[ALIGNMENT(7)]';


  put '[SELECT("C1")]';
  %if "&rowname_width." = "" %then %do;
     put '[COLUMN.WIDTH(2)]';
  %end;
  %else %do;
     put "[COLUMN.WIDTH(&rowname_width.)]";
  %end;
  

  put '[SELECT("C2")]';
  %if "&rowname2_width." = "" %then %do;
     put '[COLUMN.WIDTH(32.75)]';
  %end;
  %else %do;
     put "[COLUMN.WIDTH(&rowname2_width.)]";
  %end;
  
  /*Column Description*/
  %let last_col_group=&&col_group&start_col.;
  %let first_col=1;

  %let extra_i2 = 0;

/*  %do i=1 %to &max_col_num.;*/
  %do i=&start_col. %to &end_col.;
	%if &&empty_col&i. eq 1 and &delete_empty_col. eq 1 %then %do; 
       %let next_i=%eval(&i.+1);
	   %let extra_i2 = %eval(&extra_i2. - 1);
       %let last_col_group=&&col_group&next_i.;
	%end;
    %else %do;
      %let next_i=%eval(&i.+1);
/*      %if not(&&empty_col&i. eq 1 and &delete_empty_col. eq 1) %then %do; */
        %if &last_col_group. ne &&col_group&next_i. or &i. eq &end_col. %then %do;
		   %if "&&&&col_group_name&&col_group&i." ne "" %then %do;
              put "[SELECT(""R%eval(&table_start.)C%eval(3*&first_col.):R%eval(&table_start.)C%eval(3*(&i. -(&start_col.-1) + &extra_i2.)+1)"")]";

              /*Make sure text is not interpreted as number or date*/
              put '[format.number("@")]';
              put '[ALIGNMENT(7,1,2)]'; 
              put '[BORDER(0,0,0,0,1)]';

		   %end;

	       %let first_col=%eval(&i.-(&start_col.-1) + &extra_i2. +1);
           %let last_col_group=&&col_group&next_i.;
		%end;
/*	  %end;*/
    %end;
  %end;

  /*Date*/
/*  put "[SELECT(""R1C%eval(3*(&max_col_num. + &extra_i.)):R1C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
  put "[SELECT(""R1C%eval(3*(&cur_col_num. + &extra_i.)):R1C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
  put '[ALIGNMENT(7)]'; 

  /*  put "[SELECT(""R%eval(&table_start.+2)C1:R%eval(&table_start.+2)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
  put "[SELECT(""R%eval(&table_start.+2)C1:R%eval(&table_start.+2)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
  put '[BORDER(0,0,0,0,1)]';
  /*Title*/
/*  put "[SELECT(""R2C1:R%eval(&table_start. - &any_col_group_names.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
/*  put "[SELECT(""R2C1:R%eval(&table_start. - &any_col_group_names.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";*/
  put "[SELECT(""R2C1:R2C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
/*  put '[ALIGNMENT(2,True)]'; */
  put '[ALIGNMENT(2,1,1,,,,,1)]'; 

  %if "&title_height" ne "" %then %do;
     put "[ROW.HEIGHT(&title_height)]";
  %end;
  %else %do;
     put '[ROW.HEIGHT(,,,3)]';
  %end;
  put "[FORMAT.FONT(""&excel_font."", &excel_font_size.,1,0)]";

/*  put "[SELECT(""R2C1:R2C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
  put "[SELECT(""R2C1:R2C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
/*  put '[BORDER(0,0,0,0,1)]';*/

  /*
  %if &variable_direction.=2 %then %do;
     %let max_row_var=&max_variable_of_interest.;
     %let max_col_var=1;
     %end;
  %else %do;
     %let max_row_var=1;
     %let max_col_var=&max_variable_of_interest.;
     %end;
*/

  /*extra row formating*/
  %let k= &table_start. + 3;
  %let k_plus = 0;

/*
  %let last_group=row_group1v1;
*/
  %let last_group=row_group1;
  %let first_group= ;
  %if "&row_group_name1" ne "" %then %let j=%eval(&k.+1);

  %do i=1 %to &max_row_num.;
      %let k=%eval(&k.+1);     

	  %if &last_group. ne &&row_group&i. %then %do;
	     put "[SELECT(""R%eval(&k.)C1"")]";
         put "[FORMAT.FONT(""&excel_font."", &excel_font_size.,1,0)]";

	    %let last_group = &&row_group&i.;
	    %if "&&row_group_name&last_group." ne "" %then %let k=%eval(&k.+1);
	  %end;

	  %if &first_group. ne &&row_group&i. %then %do;
	    %if &&&&empty_row_group&&row_group&i. = 1 and &delete_empty_row. = 1 and "&&&&row_group_name&&row_group&i." ne "" %then %do;

          put "[SELECT(""R%eval(&k.)"")]";
          put '[EDIT.DELETE(2)]'; 
	      %let k=%eval(&k.-1);
		%end;
		%let first_group=&&row_group&i.;
	  %end;
 
      put "[SELECT(""R%eval(&k.)C1"")]";
      put "[FORMAT.FONT(""&excel_font."", &excel_font_size.,1,0)]";

      /*Align all estimates on the right*/
/*      put "[SELECT(""R%eval(&k.)C3:R%eval(&k.+1)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
      put "[SELECT(""R%eval(&k.)C3:R%eval(&k.+1)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
      put '[ALIGNMENT(4,,1)]';  


	  %let temp=&&row_group&i.;
	  %if "&&row_group_name&temp." ne "" %then %let start_c&i. =2;
	  %else %let start_c&i.=1;

  	  %if "&&row_height&i." ne "" %then %do;
         put "[SELECT(""R%eval(&k.)"")]";
         put "[ROW.HEIGHT(&&row_height&i.)]";
	  %end;

      /*Align row names*/
      put "[SELECT(""R%eval(&k.)C2"")]";
      put '[ALIGNMENT(2,1,1)]';  
/*      put '[ALIGNMENT(2,1,1,,2)]';  */

/*	  put "[SELECT(""R%eval(&k.)C&&start_c&i.:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
	  put "[SELECT(""R%eval(&k.)C&&start_c&i.:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";

      %if "&number_of_digits." = "0" %then %do;
		 put '[format.number("#,##0")]';
	  %end;
      %else %do;
         put '[format.number("#,##0.' @@;
		 %do num_of_digit=1 %to &number_of_digits.;
		    put '0' @@;
		 %end;
		 put '")]';
	  %end;
/*
	  %if &number_of_digits. = 1 then put '[format.number("0.0")]';
*/

      %if %index(&&row_format&i.,g)>=1 %then %do;
	  /*gray*/
/*        put "[SELECT(""R%eval(&k.)C&&start_c&i.:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
        put "[SELECT(""R%eval(&k.)C&&start_c&i.:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
        put '[PATTERNS(1,15,15,1)]';/*gray*/
        /*put '[PATTERNS(1,3,3,1)]';*//*red*/
        /*put '[PATTERNS(1,4,4,1)]';*//*green*/
        /*put '[PATTERNS(1,5,5,1)]';*//*blue*/
        /*put '[PATTERNS(1,46,46,1)]';*//*orange*/
	  %end;

      %if %index(&&row_format&i.,b)>=1 %then %do;
	  /*bold*/
/*        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
        put '[FORMAT.FONT(,,1)]';
	  %end;

      %if %index(&&row_format&i.,i)>=1 %then %do;
	  /*italic*/
/*        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
        put '[FORMAT.FONT(,,,1)]';
	  %end;

      %if %index(&&row_format&i.,u)>=1 %then %do;
	  /*underline estimates*/
/*        put "[SELECT(""R%eval(&k.)C3:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
        put "[SELECT(""R%eval(&k.)C3:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
        put '[BORDER(0,0,0,0,1)]';  
    %end;
    
      %if %index(&&row_format&i.,U)>=1 %then %do;
	  /*underline entire line*/
/*        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
        put '[BORDER(0,0,0,0,1)]';  
	  %end;

      %if %index(&&row_format&i.,l)>=1 %then %do;
	  /*draw line on top of estimates*/
/*        put "[SELECT(""R%eval(&k.)C3:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
        put "[SELECT(""R%eval(&k.)C3:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
        put '[BORDER(0,0,0,1)]';  
    %end;
    
      %if %index(&&row_format&i.,L)>=1 %then %do;
	  /*draw line on top of entire line*/
/*        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
        put '[BORDER(0,0,0,1)]';  
	  %end;

      %if %index(&&row_format&i.,t)>=1 %then %do;
	  /*Indent */
/*        put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&max_col_num. + &extra_i.)+1)"")]";*/
	    indent=index(row_format,'t');
	  	if (indent>1 and anydigit(substr(row_format,indent-1,1))>0) then do;
    		 num_indent = int(substr(row_format,indent-1,1));
  		end;
        put "[SELECT(""R%eval(&k.)C2:R%eval(&k.)C2"")]";
        put '[ALIGNMENT(,,,,,1)]';  

/*%put "Try Indent";*/

	  %end;

      %if %index(&&row_format&i.,d)>=1 %then %do;
	  /*delete*/
        put "[SELECT(""R%eval(&k.)"")]";
        put '[EDIT.DELETE(2)]'; 
	    %let k=%eval(&k.-1);
		%if &&extra_row&i. > 0 %then %do;
           put "[SELECT(""R%eval(&k.+1):R%eval(&k.+&&extra_row&i.)"")]";
           put '[EDIT.DELETE(2)]'; 
	       %let k=%eval(&k.-&&extra_row&i.);
		%end;
	  %end;


      %if "&&extra_row&i." ne "" %then %do;
         %let k=%eval(&k.+&&extra_row&i.);
	  %end;

  %end;

/*footnote formating*/
  %if %bquote(&footnote.) ne "" %then %do; 
    %let k=%eval(&k.+1);     
    put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
    put "[FORMAT.FONT(""&excel_font."", %eval(&excel_font_size.-2),0,0)]";
    put '[ALIGNMENT(2,1,1,,,,,1)]'; 

    put "[SELECT(""R%eval(&k.)"")]";
  	%if "&footnote_height." ne "" %then %do;
      put "[ROW.HEIGHT(&footnote_height)]";
	%end;
	%else %do;
      put '[ROW.HEIGHT(,,,3)]';
	%end;
  %end;
  %do foot_i=1 %to 3;
    %if "&&footnote&foot_i." ne "" %then %do; 
      %let k=%eval(&k.+1);     
      put "[SELECT(""R%eval(&k.)C1:R%eval(&k.)C%eval(3*(&cur_col_num. + &extra_i.)+1)"")]";
      put "[FORMAT.FONT(""&excel_font."", %eval(&excel_font_size.-2),0,0)]";
      put '[ALIGNMENT(2,1,1,,,,,1)]'; 
      put '[ROW.HEIGHT(,,,3)]';

      put "[SELECT(""R%eval(&k.)"")]";
  	  %if "&&footnote_height&foot_i." ne "" %then %do;
        put "[ROW.HEIGHT(&&footnote_height&foot_i.)]";
	  %end;
	  %else %do;
        put '[ROW.HEIGHT(,,,3)]';
	  %end;
    %end;
  %end;

  /*
  put "[SELECT(""R1C1:R%eval(&k.)C%eval(3*&max_col_num.+1)"")]";
  put '[SET.PRINT.AREA("")]' ;
  put '[SET.PRINT.AREA()]' ;
  */
  %if &color_large_value. = 1 %then %do;
    %let red_num_run=1;
    %if "&redline." ne "" %then %do;
      %do %until (%scan(%bquote(&redline.), &red_num_run,',') eq );
        %let red_curr = %scan(%bquote(&redline.), &red_num_run.,',');
  	    %let red_num_run = %sysevalf(&red_num_run.+1);
        put "[SELECT(""&red_curr."")]";
        put '[PATTERNS(1,3,3,1)]';/*red*/
	  %end;
    %end;

    %let orange_num_run=1;
    %if "&orangeline." ne "" %then %do;
      %do %until (%scan(%bquote(&orangeline.), &orange_num_run,',') eq );
        %let orange_curr = %scan(%bquote(&orangeline.), &orange_num_run.,',');
	    %let orange_num_run = %sysevalf(&orange_num_run.+1);
        put "[SELECT(""&orange_curr."")]";
        put '[PATTERNS(1,44,44,1)]';/*orange*/
      %end;
    %end;
  %end;

  put '[SELECT("R1C1")]';
  %if &paper_size. = 1 %then %let size=1;
  %else %let size=5;
  if &fit_one_page.=1 then
    put "[PAGE.SETUP(,,0.5,0.5,0.5,0.5,,,,,&page_orientation.,&size.,TRUE)]";
  else
    put "[PAGE.SETUP(,,0.5,0.5,0.5,0.5,,,,,&page_orientation.,&size)]";

  put "[SAVE()]";
  put '[close()]';
*  put '[quit()]';

run;


%if &max_replace. ge 0 %then %do;
  filename vbs_file "&xls_dir.replace.vbs" lrecl=1048576;
  data _null_;
  file vbs_file;
  put 'On Error Resume Next';
  put;
  put 'Set XL = CreateObject("Excel.Application")';
  put 'XL.Visible=True';
  put 'XL.Workbooks.Open "'"&xls_dir.&xls_file."'"';
  put;
  put "XL.Application.DisplayAlerts = False";
  put;
  %do replace = 1 %to &max_replace.;
    put 'XL.Cells.Replace("'"&&replace_from&replace."'",' "&&replace_to&replace."').Activate';
  %end;
  put;

  put 'XL.ActiveWorkbook.BuiltinDocumentProperties("Comments").Value = "OK Tabling Version '"&version."'"' @@;

  %if  "&datasource_nims_40." ne "" %then %do;
    put ' + ChrW(13) + ChrW(10) + "NIMS version 4.0" + ChrW(13) + ChrW(10)+ "Based on database '"&access_file. "'" ' @@;
    %if &ppsa_source.=4 or &eus_source.=4 %then %do;
        put '+ ChrW(13) + ChrW(10)+ "A seperate SAS library was used as part of the stratification"' ;
    %end;
  %end;
  %else %if  "&datasource_fiadb_40." ne "" %then %do;
    put ' + ChrW(13) + ChrW(10) + "FIADB version 4.0" + ChrW(13) + ChrW(10)+ "Based on database '"&access_file. "'" ' @@;
    %if &pop_plot_stratum_assgn_source.=4 %then %do;
        put '+ ChrW(13) + ChrW(10)+ "A seperate SAS library was used as part of the stratification"' ;
    %end;
  %end;

  put '';
  put 'XL.ActiveWorkbook.Save';
  put 'XL.Workbooks.Close';
  put 'XL.Quit';
  run;


  options xsync noxwait;

  x %str(%'%")&xls_dir.replace.vbs%str(%"%');

  filename tmp "&xls_dir.replace.vbs";
  data _null_;
    rc=fdelete('tmp');
  run;
  options noxsync noxwait;

%end;
%end;
%end;


%if &count_plots_non_zero.=1 %then %do;

  proc print data = evalid_&evalid_curr.(where=(not(id in (&exclude_row.)))) split='*' noobs;
  var row_name 
    %if &variable_directionx.=2 %then %do;
      variable_name
    %end;
    %let run_exclude=1;
    %do col_run=1 %to &max_col_num.;
      %do var_run=1 %to &temp_var.;
	    %if %not_in(&run_exclude.,&exclude_col.) %then %do;
	      col_num_%eval(100*&col_run +&var_run.) 
	    %end;
	    %let run_exclude=%eval(&run_exclude.+1);
      %end;
    %end;
    ;

    label row_name="&row_var_name_out. ";
    %do col_run=1 %to &max_col_num.;
      %do var_run=1 %to &max_variable_of_interest.;
	     label
           col_num_%eval(100*&col_run +&var_run.) = "&&col_description&col_run.*&&variable_desc&var_run. " ;
         format col_num_%eval(100*&col_run +&var_run.) comma8.;
	          
	  %end;
    %end;

  title1 "&title_name. ";
  title2 "&evaldescr_curr. ";
  title3 Number of plots with values larger zero;
  run;
%end;

%if &export_column_format_yes.=1 %then %do;
  %export_column_format;
  
  proc export data = column_output
     outtable = "&use_sheet_name."
	 dbms=access
	 replace;
	 database="&xls_dir.&xls_file..mdb";
  run;

%end;

%end;

%if &display_tables.=2 and &close_excel_sheet. ne 1 %then %do;
/*data _null_;
  file ddecmds;
  if fileexist("&xls_dir.&xls_file.") and &close_excel_sheet. ne 1 then
    put "[open(""&xls_dir.&xls_file."")]";
	put "[SAVE()]";
run;*/
%end;

%do i=1 %to 500;
     %let row_format&i. =&&old_row_format&i.;
%end;

%mend;

/*
%xls_print;
*/
